<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
<topic id="wh-configure-custom-search-engine">
  <title>How to Configure a Custom Search Engine</title>
  <prolog>
    <metadata>
      <keywords>
        <indexterm product="author developer editor authorEclipse developerEclipse editorEclipse"
          >WebHelp Responsive<indexterm>Custom search engine</indexterm></indexterm>
        <indexterm product="webhelp">Custom search engine</indexterm>
      </keywords>
    </metadata>
  </prolog>
  <body>
    <p id="p_kt4_cgk_54b">It is possible to integrate a custom search engine into your WebHelp Responsive output. This
      is done by using the following transformation parameters:</p>
    <p id="p_lt4_cgk_54b">
      <dl id="dl_v43_bvc_p4b">
        <dlentry id="dlentry_mt4_cgk_54b">
          <dt>webhelp.fragment.custom.search.engine.results</dt>
          <dd>This parameter can be used to replace the search results area with custom XHTML
            content. The value of the parameter is the path to an XHTML file that contains your
            custom content.</dd>
        </dlentry>
        <dlentry id="dlentry_nt4_cgk_54b">
          <dt>webhelp.fragment.custom.search.engine.script</dt>
          <dd>This parameter can be used to replace WebHelp's built-in search engine with your own
            custom search engine. The value of the parameter is the path to an XHTML file that
            contains the scripts required for your custom search engine to run.</dd>
        </dlentry>
      </dl>
    </p>
    <p id="p_ot4_cgk_54b">To integrate a custom search engine into your WebHelp Responsive output, follow these steps: <ol id="ol_pt4_cgk_54b">
        <li id="li_qt4_cgk_54b">If you have not already created a Publishing Template, see <xref
            href="whr-create-publishing-template.dita">How to Create a Publishing
          Template</xref>.</li>
        <li id="li_rt4_cgk_54b">Create the following items in the folder that contains your publishing descriptor file
          (the <filepath>.opt</filepath> file):<itemgroup>
            <ul id="ul_st4_cgk_54b">
              <li id="li_tt4_cgk_54b">A file named <filepath>custom-search-results-fragment.xml</filepath>. </li>
              <li id="li_ut4_cgk_54b">A file named <filepath>custom-search-script-fragment.xml</filepath>.</li>
              <li id="li_vt4_cgk_54b">A folder named <filepath>js</filepath>. </li>
            </ul>
          </itemgroup></li>
        <li id="li_wt4_cgk_54b">In the <b>custom-search-results-fragment.xml</b> file, define the HTML structure that
          will be used as the search results area. For example: <itemgroup>
            <codeblock  id="codeblock_xt4_cgk_54b">&lt;div id="cumstom-search-results">...&lt;/div></codeblock>
            <note id="note_yt4_cgk_54b">The custom search engine script will need to find an HTML element from the HTML
              structure that will be used as the search results area and write the search results
              inside it. In this example, it is the <xmlelement>div</xmlelement> element with the id
                <i>custom-search-results</i>.</note>
          </itemgroup></li>
        <li id="li_zt4_cgk_54b">In the <b>js</b> folder, create a file named <b>custom-search.js</b>. </li>
        <li id="li_a54_cgk_54b">As a starting point, you can copy the following content to the <b>custom-search.js</b>
          file: <itemgroup>
            <codeblock  id="codeblock_b54_cgk_54b">document.addEventListener('DOMContentLoaded', (event) => {
    const params = new URLSearchParams(window.location.search);
    const searchQuery = params.get('searchQuery');
    // Implement your custom search engine
    // Display the search results
});</codeblock>
            <note type="important" id="note_c54_cgk_54b">The value entered by the user in the search page will be
              available in the URL's query parameters in a parameter named
                <codeph>searchQuery</codeph>.</note>
            <note type="attention" id="note_d54_cgk_54b"><i>URLSearchParams</i> is not supported on all browsers (it is
              used as an example). A list with the supported browsers can be found <xref
                href="https://developer.mozilla.org/en-US/docs/Web/API/URLSearchParams#browser_compatibility"
                format="html" scope="external">here</xref>. A different solution should be used if
              you need to support other browsers. </note>
          </itemgroup></li>
        <li id="li_e54_cgk_54b">Implement your custom search engine. <itemgroup>
            <note type="note" id="note_f54_cgk_54b">The search results should be pushed into the
                <xmlelement>div</xmlelement> element created earlier with the id
                <i>custom-search-results</i>.</note>
          </itemgroup></li>
        <li id="li_g54_cgk_54b">In the <b>custom-search-script-fragment.xml</b> file, define the scripts that are
          required for your custom search engine to run. For example: <itemgroup>
            <codeblock  id="codeblock_h54_cgk_54b">&lt;div>
    &lt;script src="${oxygen-webhelp-template-dir}/js/custom-search.js">&lt;/script>
&lt;/div></codeblock>
          </itemgroup></li>
        <li id="li_i54_cgk_54b">Copy the <b>js</b> folder to the output folder during the transformation process. For
          this, open the <filepath>.opt</filepath> file and add the following content in the
            <xmlelement>resources</xmlelement> section (see <xref
            href="whr_publishing_template_contents.dita#template_resources">Template
            Resources</xref> for more details):<itemgroup>
            <codeblock  id="codeblock_j54_cgk_54b">&lt;fileset>
  &lt;include name="js/**"/>
&lt;/fileset></codeblock>
          </itemgroup></li>
        <li id="li_k54_cgk_54b">Set the transformation parameters needed to enable the custom search engine. For this,
          open the <filepath>.opt</filepath> file and add the following content inside the
            <xmlelement>webhelp</xmlelement> element: <itemgroup>
            <codeblock  id="codeblock_l54_cgk_54b">&lt;html-fragments>
  &lt;fragment file="custom-search-script-fragment.xml" 
      placeholder="webhelp.fragment.custom.search.engine.script"/>
  &lt;fragment file="custom-search-results-fragment.xml" 
      placeholder="webhelp.fragment.custom.search.engine.results"/>
&lt;/html-fragments></codeblock>
          </itemgroup></li>
        <li id="li_m54_cgk_54b"> Run the transformation with this publishing template selected.<note
            id="note_n54_cgk_54b" type="tip">A sample publishing template that overrides WebHelp's
            default search engine is available to download <xref
              href="https://github.com/oxygenxml/oxygen-publishing-template-samples/tree/master/templates/custom-search-engine"
              format="html" scope="external"> here</xref>. You can use it as a starting point for
            your customization. </note>
        </li>
      </ol></p>
  </body>
</topic>
